#include "Object.h"
#include "Polymorphism.h"

Object::Object(olc::vf2d pos,float dir,olc::vf2d spd,olc::Renderable&img,bool friendly)
	:pos(pos),dir(dir),spd(spd),img(img),friendly(friendly),radius(img.Sprite()->width/2){}

void Object::InternalUpdate(Polymorphism*pge,float fElapsedTime){
	if(spd.y!=0||spd.x!=0){
		dir=atan2(spd.y,spd.x);
	}
	
	pos+=spd*fElapsedTime;
	
	if(pos.x<0){
		pos.x=0;
	}
	if(pos.y<0){
		pos.y=0;
	}
	if(pos.x>=pge->ScreenWidth()){
		pos.x=pge->ScreenWidth();
	}
	if(pos.y>=pge->ScreenHeight()){
		pos.y=pge->ScreenHeight();
	}

	if(spd.x>0){
		spd.x-=FRICTION*fElapsedTime;
		if(spd.x<=0){
			spd.x=0;
		}
	}
	if(spd.x<0){
		spd.x+=FRICTION*fElapsedTime;
		if(spd.x>=0){
			spd.x=0;
		}
	}
	if(spd.y>0){
		spd.y-=FRICTION*fElapsedTime;
		if(spd.y<=0){
			spd.y=0;
		}
	}
	if(spd.y<0){
		spd.y+=FRICTION*fElapsedTime;
		if(spd.y>=0){
			spd.y=0;
		}
	}
}

void Object::Draw(Polymorphism*pge,float fElapsedTime){
	pge->DrawRotatedDecal(pos,img.Decal(),
		dir,img.Sprite()->Size()/2,{1,1},col);
}